use bitboard::Bitboard;
use game::Game;

use std::sync::mpsc::{Receiver, Sender};
use movegen::*;

pub enum EngineMsg {
    SetBoard([Bitboard; 12]),
    SetPiece(Bitboard),
    Search(i32),
    Ping,
    Stop,
    GetState,
    GetInfo,
}


pub enum EngineState {
    Idle,
    Searching
}


pub enum InterfaceMsg {
    BestMove(Move),
    State(EngineState)
}


pub fn run_engine(r: Receiver<EngineMsg>, s: Sender<InterfaceMsg>) {
    let mut game = Game::default();
    for msg in r {
        //game.pieces[0] = 0x00ff_0000_0000_0100;
        //game.pieces[QUEEN as usize] = 0x0000_0000_0000_0080;
        //game.pieces[10] = 0x4000_0000_0000_0000;

        println!("{}", game.beautiful_print());

        let moves = generate_moves(&game, WHITE);
        for mov in moves {
            println!("move: {:?}", mov);
        }
    }
}

